unit WaveObj;

interface

type
  PByte = ^Byte;
  PInt = ^LongInt;
  PFloat = ^Single;
  TFourCC = record
    case Boolean of
    false: (Value: LongWord);
    true: (Text: packed array[0..3] of Char)
  end;
  TRIFFHeader = record
    RIFF_ID: TFourCC;
    Size: LongWord;
    SubType: TFourCC
  end;
  PChunk = ^TChunk;
  TChunk = object
    ChunkID: TFourCC;
    Size: LongWord
  end;
  PMiscChunk = ^TMiscChunk;
  TMiscChunk = object(TChunk)
    Data: Pointer
  end;
  PFormatChunk = ^TFormatChunk;
  TFormatChunk = object(TChunk)
    wFormatTag: Word;
    wChannels: Word;
    dwSamplesPerSec: LongWord;
    dwAvgBytesPerSec: LongWord;
    wBlockAlign: Word;
    wBitsPerSample: Word;
    cbSize: Word
  end;
  PDataChunk = ^TDataChunk;
  TDataChunk = object(TChunk)
  end;
  TWaveHeader = record
    RIFF: TRIFFHeader;
    fmt: TFormatChunk;
    data: TDataChunk
  end;
  TPerSampleFunction = function(Value: Single): Single;

const
  WAVE_FORMAT_PCM = 1;
  WAVE_FORMAT_IEEE_FLOAT = 3;
  rmRIFF: TFourCC = (Text: 'RIFF');
  rtWAVE: TFourCC = (Text: 'WAVE');
  chFmt: TFourCC = (Text: 'fmt ');
  chData: TFourCC = (Text: 'data');
  Div32b: LongWord = $80000000;
  SecPerDay = 24*60*60;
  SEEK_ERROR = $FFFFFFFF;
                                
implementation

end.
